<?xml version="1.0" encoding="ISO-8859-1"?> 

<!-- $Id: bddfilt-flat.xsl,v 1.4 2002/08/30 15:47:49 fenyo Exp $ -->

<xsl:stylesheet
  version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:lxslt="http://xml.apache.org/xslt">

<xsl:output encoding="ISO-8859-1" indent="yes"/>

<!-- ************************************************************ -->
<!-- clean output -->

<xsl:template match="text()">
  <xsl:value-of select="normalize-space(.)"/>
</xsl:template>

<!-- ************************************************************ -->
<!-- minimal attribute set for `assign' element -->

<xsl:attribute-set name="assign_minimal">

  <!-- insert `identity' attribute relative to nearest surrounding element -->
  <xsl:attribute name="identity">
    <xsl:variable name="ancestors" select="ancestor::*/@identity|@identity"/>
    <xsl:value-of select="string($ancestors[count($ancestors)])"/>
  </xsl:attribute>

  <!-- insert `date' attribute relative to nearest surrounding element -->
  <xsl:attribute name="date">
    <xsl:variable name="ancestors" select="ancestor::*/@date|@date"/>
    <xsl:value-of select="string($ancestors[count($ancestors)])"/>
  </xsl:attribute>

  <!-- insert `time' attribute relative to nearest surrounding element -->
  <xsl:attribute name="time">
    <xsl:variable name="ancestors" select="ancestor::*/@time|@time"/>
    <xsl:value-of select="string($ancestors[count($ancestors)])"/>
  </xsl:attribute>

  <!-- insert `microsec' attribute relative to nearest surrounding element -->
  <xsl:attribute name="microsec">
    <xsl:variable name="ancestors" select="ancestor::*/@microsec|@microsec"/>
    <xsl:value-of select="string($ancestors[count($ancestors)])"/>
  </xsl:attribute>

  <!-- insert `key' attribute relative to nearest surrounding element -->
  <xsl:attribute name="key">
    <xsl:variable name="ancestors" select="ancestor::*/@key|@key"/>
    <xsl:value-of select="string($ancestors[count($ancestors)])"/>
  </xsl:attribute>

  <!-- insert `value' attribute relative to nearest surrounding element -->
  <xsl:attribute name="value">
    <xsl:variable name="ancestors" select="ancestor::*/@value|@value"/>
    <xsl:value-of select="string($ancestors[count($ancestors)])"/>
  </xsl:attribute>

  <!-- insert `ref' attribute relative to nearest surrounding element -->
  <xsl:attribute name="ref">
    <xsl:variable name="ancestors" select="ancestor::*/@ref|@ref"/>
    <xsl:value-of select="string($ancestors[count($ancestors)])"/>
  </xsl:attribute>

</xsl:attribute-set>

<!-- ************************************************************ -->

<xsl:template match="assign">
  <xsl:copy use-attribute-sets="assign_minimal">
  </xsl:copy>
</xsl:template>

<!-- ************************************************************ -->

<xsl:template match="gnetwatch">
  <xsl:copy>
    <xsl:copy-of select="@*"/>
    <xsl:apply-templates/>
  </xsl:copy>
</xsl:template>

<!-- ************************************************************ -->

</xsl:stylesheet>
